package com.daim.apm

import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result

/** ApmPlugin */
class ApmPlugin: FlutterPlugin {
  private lateinit var apmModule : ApmModule
  private lateinit var apmUiServicesUserModule: ApmUiServicesUserModule

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    //APMModule
    apmModule = ApmModule()
    apmModule.onAttachedToEngine(flutterPluginBinding)

    //APMUIServicesUserModule
    apmUiServicesUserModule = ApmUiServicesUserModule()
    apmUiServicesUserModule.onAttachedToEngine(flutterPluginBinding)
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    apmModule.onDetachedFromEngine(binding) //APMModule
    apmUiServicesUserModule.onDetachedFromEngine(binding) //APMUIServicesUserModule
  }
}
