import Flutter
import UIKit

public class ApmModule: NSObject, FlutterPlugin {
    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = ApmModule()
        let channel = FlutterMethodChannel(name: "apm_module", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        if (call.method.elementsEqual("getPlatformVersion")) {
            getPlatformVersion(result: result)
        } else {
            result(FlutterMethodNotImplemented)
        }
    }
    
    private func getPlatformVersion(result: FlutterResult) {
        result("iOS " + UIDevice.current.systemVersion)
    }
}
